Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class AddEditCustomerDemographics

        Dim _isCustomerTypeIDValid As Boolean
        Dim _customerTypeID As String
        Private _operation As CrudOperation

        Public Property CustomerTypeID() As String
            Get
                Return _customerTypeID
            End Get
            Set(ByVal value As String)
                _customerTypeID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtCustomerTypeID_TextChanged(sender As Object, e As EventArgs) Handles TxtCustomerTypeID.TextChanged
            If Not String.IsNullOrEmpty(TxtCustomerTypeID.Text) Then
                TxtCustomerTypeID.BackColor = Color.White
                _isCustomerTypeIDValid = True
            Else
                _isCustomerTypeIDValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateCustomerDemographics()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isCustomerTypeIDValid Then
                errors += "Customer Type ID is required!" & vbCrLf
                TxtCustomerTypeID.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetCustomerDemographicsToEdit()
            Dim objCustomerDemographics As CustomerDemographics = CustomerDemographics.SelectByPrimaryKey(CustomerTypeID)

            If objCustomerDemographics IsNot Nothing Then
                TxtCustomerTypeID.Text = objCustomerDemographics.CustomerTypeID
                TxtCustomerDesc.Text = objCustomerDemographics.CustomerDesc
            End If
        End Sub

        Private Sub AddOrUpdateCustomerDemographics()
            Dim objCustomerDemographics As CustomerDemographics

            If Operation = CrudOperation.Add Then
                objCustomerDemographics = New CustomerDemographics()
            Else
                objCustomerDemographics = CustomerDemographics.SelectByPrimaryKey(CustomerTypeID)
                objCustomerDemographics.CustomerTypeID = CustomerTypeID
            End If

            If String.IsNullOrEmpty(TxtCustomerDesc.Text.Trim()) Then
                objCustomerDemographics.CustomerDesc = Nothing
            Else
                objCustomerDemographics.CustomerDesc = TxtCustomerDesc.Text.ToString()
            End If


            Try
                If Operation = CrudOperation.Add Then
                    objCustomerDemographics.Insert()
                Else
                    objCustomerDemographics.Update()
                End If
            Catch ex As Exception
                If Operation = CrudOperation.Add Then
                    MessageBox.Show(ex.Message, "An error occured on item insertion!")
                Else
                    MessageBox.Show(ex.Message, "An error occured on item update!")
                End If
            End Try
        End Sub
    End Class
