Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class AddEditShippers

        Dim _isCompanyNameValid As Boolean
        Dim _shipperID As Integer
        Private _operation As CrudOperation

        Public Property ShipperID() As Integer
            Get
                Return _shipperID
            End Get
            Set(ByVal value As Integer)
                _shipperID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtCompanyName_TextChanged(sender As Object, e As EventArgs) Handles TxtCompanyName.TextChanged
            If Not String.IsNullOrEmpty(TxtCompanyName.Text) Then
                TxtCompanyName.BackColor = Color.White
                _isCompanyNameValid = True
            Else
                _isCompanyNameValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateShippers()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isCompanyNameValid Then
                errors += "Company Name is required!" & vbCrLf
                TxtCompanyName.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetShippersToEdit()
            Dim objShippers As Shippers = Shippers.SelectByPrimaryKey(ShipperID)

            If objShippers IsNot Nothing Then
                TxtShipperID.Text = objShippers.ShipperID.ToString()
                TxtCompanyName.Text = objShippers.CompanyName
                TxtPhone.Text = objShippers.Phone
            End If
        End Sub

        Private Sub AddOrUpdateShippers()
            Dim objShippers As Shippers

            If Operation = CrudOperation.Add Then
                objShippers = New Shippers()
            Else
                objShippers = Shippers.SelectByPrimaryKey(ShipperID)
                objShippers.ShipperID = ShipperID
            End If

            objShippers.CompanyName = TxtCompanyName.Text.ToString()

            If String.IsNullOrEmpty(TxtPhone.Text.Trim()) Then
                objShippers.Phone = Nothing
            Else
                objShippers.Phone = TxtPhone.Text.ToString()
            End If


            Try
                If Operation = CrudOperation.Add Then
                    objShippers.Insert()
                Else
                    objShippers.Update()
                End If
            Catch ex As Exception
                If Operation = CrudOperation.Add Then
                    MessageBox.Show(ex.Message, "An error occured on item insertion!")
                Else
                    MessageBox.Show(ex.Message, "An error occured on item update!")
                End If
            End Try
        End Sub
    End Class
