Imports System
Imports System.Data
Imports NorthwindWinFormDynamic_VB.DataLayer
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for CustomerDemographics.  Do not make changes to this class,
     ''' instead, put additional code in the CustomerDemographics class
     ''' </summary>
     Public Class CustomerDemographicsBase
         ' private members
         Private _customerTypeID As String
         Private _customerDesc As String

         ''' <summary>
         ''' Gets or Sets CustomerTypeID
         ''' </summary>
         Public Property CustomerTypeID() As String
             Get
                 Return _customerTypeID
             End Get
             Set(ByVal value As String)
                 _customerTypeID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CustomerDesc
         ''' </summary>
         Public Property CustomerDesc() As String
             Get
                 Return _customerDesc
             End Get
             Set(ByVal value As String)
                 _customerDesc = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Selects a record by primary key(s)
         ''' </summary>
         Public Shared Function SelectByPrimaryKey(ByVal customerTypeID As String) As CustomerDemographics
             Return CustomerDemographicsDataLayer.SelectByPrimaryKey(customerTypeID)
         End Function

         ''' <summary>
         ''' Gets the total number of records in the CustomerDemographics table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return CustomerDemographicsDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Gets the total number of records in the CustomerDemographics table based on search parameters
         ''' </summary>
         Public Shared Function GetRecordCountDynamicWhere(customerTypeID As String) As Integer
             Return CustomerDemographicsDataLayer.GetRecordCountDynamicWhere(customerTypeID)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerDemographics sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As CustomerDemographicsCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return CustomerDemographicsDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerDemographics sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As CustomerDemographicsCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return CustomerDemographicsDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerDemographics sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex, based on the search parameters
         ''' </summary>
         Public Shared Function SelectSkipAndTakeDynamicWhere(customerTypeID As String, rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As CustomerDemographicsCollection
             totalRowCount = GetRecordCountDynamicWhere(customerTypeID)
             sortByExpression = GetSortExpression(sortByExpression)
             Return CustomerDemographicsDataLayer.SelectSkipAndTakeDynamicWhere(customerTypeID, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of CustomerDemographics sorted by the sortByExpression starting from the startRowIndex, based on the search parameters
         ''' </summary>
         Public Shared Function SelectSkipAndTakeDynamicWhere(customerTypeID As String, rows As Integer, startRowIndex As Integer, sortByExpression As String) As CustomerDemographicsCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return CustomerDemographicsDataLayer.SelectSkipAndTakeDynamicWhere(customerTypeID, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects all records as a collection (List) of CustomerDemographics
         ''' </summary>
         Public Shared Function SelectAll() As CustomerDemographicsCollection
             Return CustomerDemographicsDataLayer.SelectAll()
         End Function

         ''' <summary>
         ''' Selects all records as a collection (List) of CustomerDemographics sorted by the sort expression
         ''' </summary>
         Public Shared Function SelectAll(sortExpression As String) As CustomerDemographicsCollection
             Dim objCustomerDemographicsCol As CustomerDemographicsCollection = CustomerDemographicsDataLayer.SelectAll()
             Return SortByExpression(objCustomerDemographicsCol, sortExpression)
         End Function

         ''' <summary>
         ''' Selects records based on the passed filters as a collection (List) of CustomerDemographics.
         ''' </summary>
         Public Shared Function SelectAllDynamicWhere(customerTypeID As String) As CustomerDemographicsCollection
             Return CustomerDemographicsDataLayer.SelectAllDynamicWhere(customerTypeID)
         End Function

         ''' <summary>
         ''' Selects records based on the passed filters as a collection (List) of CustomerDemographics sorted by the sort expression.
         ''' </summary>
         Public Shared Function SelectAllDynamicWhere(customerTypeID As String, sortExpression As String) As CustomerDemographicsCollection
             Dim objCustomerDemographicsCol As CustomerDemographicsCollection = CustomerDemographicsDataLayer.SelectAllDynamicWhere(customerTypeID)
             Return SortByExpression(objCustomerDemographicsCol, sortExpression)
         End Function

         ''' <summary>
         ''' Selects CustomerTypeID and CustomerDesc columns for use with a DropDownList web control, ComboBox, CheckedBoxList, ListView, ListBox, etc
         ''' </summary>
         Public Shared Function SelectCustomerDemographicsDropDownListData() As CustomerDemographicsCollection
             Return CustomerDemographicsDataLayer.SelectCustomerDemographicsDropDownListData()
         End Function

         ''' <summary>
         ''' Sorts the CustomerDemographicsCollection by sort expression
         ''' </summary>
         Public Shared Function SortByExpression(objCustomerDemographicsCol As CustomerDemographicsCollection, sortExpression As String) As CustomerDemographicsCollection
             Dim isSortDescending As Boolean = sortExpression.ToLower().Contains(" desc")

             If isSortDescending Then
                 sortExpression = sortExpression.Replace(" DESC", "")
                 sortExpression = sortExpression.Replace(" desc", "")
             Else
                 sortExpression = sortExpression.Replace(" ASC", "")
                 sortExpression = sortExpression.Replace(" asc", "")
             End If

             Select Case sortExpression
                 Case "CustomerTypeID"
                     objCustomerDemographicsCol.Sort(CustomerDemographics.ByCustomerTypeID)
                     Exit Select
                 Case "CustomerDesc"
                     objCustomerDemographicsCol.Sort(CustomerDemographics.ByCustomerDesc)
                     Exit Select
                 Case Else
                     Exit Select
             End Select

             If isSortDescending Then
                 objCustomerDemographicsCol.Reverse()
             End If

             Return objCustomerDemographicsCol
         End Function

         ''' <summary>
         ''' Inserts a record
         ''' </summary>
         Public Function Insert() As String
             Dim objCustomerDemographics As CustomerDemographics = DirectCast(Me, CustomerDemographics)
             Return CustomerDemographicsDataLayer.Insert(objCustomerDemographics)
         End Function

         ''' <summary>
         ''' Updates a record
         ''' </summary>
         Public Sub Update()
             Dim objCustomerDemographics As CustomerDemographics = DirectCast(Me, CustomerDemographics)
             CustomerDemographicsDataLayer.Update(objCustomerDemographics)
         End Sub

         ''' <summary>
         ''' Deletes a record based on primary key(s)
         ''' </summary>
         Public Shared Sub Delete(ByVal customerTypeID As String)
             CustomerDemographicsDataLayer.Delete(customerTypeID)
         End Sub

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "CustomerTypeID"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares CustomerTypeID used for sorting
         ''' </summary>
         Public Shared ByCustomerTypeID As Comparison(Of CustomerDemographics) =
         Function(ByVal x As CustomerDemographics, ByVal y As CustomerDemographics)
             Dim value1 As String = If(x.CustomerTypeID, String.Empty)
             Dim value2 As String = If(y.CustomerTypeID, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares CustomerDesc used for sorting
         ''' </summary>
         Public Shared ByCustomerDesc As Comparison(Of CustomerDemographics) =
         Function(ByVal x As CustomerDemographics, ByVal y As CustomerDemographics)
             Dim value1 As String = If(x.CustomerDesc, String.Empty)
             Dim value2 As String = If(y.CustomerDesc, String.Empty)
             Return value1.CompareTo(value2)
         End Function

     End Class
End Namespace
