Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for CustomerDemographicsDataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the CustomerDemographicsDataLayer class
     ''' </summary>
     Public Class CustomerDemographicsDataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Selects a record by primary key(s)
         ''' </summary>
         Public Shared Function SelectByPrimaryKey(ByVal customerTypeID As String) As CustomerDemographics
              Dim objCustomerDemographics As CustomerDemographics = Nothing
              Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectByPrimaryKey()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' parameters
                      command.Parameters.AddWithValue("@customerTypeID", customerTypeID)

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCustomerDemographics = CreateCustomerDemographicsFromDataRowShared(dt.Rows(0))
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCustomerDemographics
         End Function

         ''' <summary>
         ''' Gets the total number of records in the CustomerDemographics table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = CustomerDemographicsSql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Gets the total number of records in the CustomerDemographics table based on search parameters
         ''' </summary>
         Public Shared Function GetRecordCountDynamicWhere(customerTypeID As String) As Integer
              Dim recordCount As Integer = 0
              Dim dynamicSqlScript As String = CustomerDemographicsSql.GetRecordCountDynamicWhere()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' search parameters
                      AddSearchCommandParamsShared(command, customerTypeID)

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects CustomerDemographics records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As CustomerDemographicsCollection
             Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects CustomerDemographics records sorted by the sortByExpression and returns records between the start and end based on search parameters
         ''' </summary>
         Public Shared Function SelectSkipAndTakeDynamicWhere(customerTypeID As String, sortByExpression As String, startRowIndex As Integer, rows  As Integer) As CustomerDemographicsCollection
              Dim  objCustomerDemographicsCol As CustomerDemographicsCollection = Nothing
              Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectSkipAndTakeDynamicWhere()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      command.Parameters.AddWithValue("@start", startRowIndex)
                      command.Parameters.AddWithValue("@numberOfRows", rows)
                      command.Parameters.AddWithValue("@sortByExpression", sortByExpression)

                      ' search parameters
                      AddSearchCommandParamsShared(command, customerTypeID)

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCustomerDemographicsCol = New CustomerDemographicsCollection()

                                  For Each dr As DataRow in dt.Rows
                                      Dim objCustomerDemographics As CustomerDemographics = CreateCustomerDemographicsFromDataRowShared(dr)
                                      objCustomerDemographicsCol.Add(objCustomerDemographics)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCustomerDemographicsCol
         End Function

         ''' <summary>
         ''' Selects all CustomerDemographics
         ''' </summary>
         Public Shared Function SelectAll() As CustomerDemographicsCollection
             Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectAll()
             Return SelectShared(dynamicSqlScript, String.Empty, Nothing)
         End Function

         ''' <summary>
         ''' Selects records based on the passed filters as a collection (List) of CustomerDemographics.
         ''' </summary>
         Public Shared Function SelectAllDynamicWhere(customerTypeID As String) As CustomerDemographicsCollection
              Dim objCustomerDemographicsCol As CustomerDemographicsCollection = Nothing
              Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectAllDynamicWhere()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' search parameters
                      AddSearchCommandParamsShared(command, customerTypeID)

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCustomerDemographicsCol = New CustomerDemographicsCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objCustomerDemographics As CustomerDemographics = CreateCustomerDemographicsFromDataRowShared(dr)
                                      objCustomerDemographicsCol.Add(objCustomerDemographics)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCustomerDemographicsCol
         End Function

         ''' <summary>
         ''' Selects CustomerTypeID and CustomerDesc columns for use with a DropDownList web control
         ''' </summary>
         Public Shared Function SelectCustomerDemographicsDropDownListData() As CustomerDemographicsCollection
              Dim objCustomerDemographicsCol As CustomerDemographicsCollection = Nothing
              Dim dynamicSqlScript As String = CustomerDemographicsSql.SelectCustomerDemographicsDropDownListData()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCustomerDemographicsCol = New CustomerDemographicsCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objCustomerDemographics As CustomerDemographics  = New CustomerDemographics()
                                      objCustomerDemographics.CustomerTypeID = DirectCast(dr("CustomerTypeID"), String)

                                      If Not dr("CustomerDesc").Equals(System.DBNull.Value) Then
                                          objCustomerDemographics.CustomerDesc = DirectCast(dr("CustomerDesc"), String)
                                      Else
                                          objCustomerDemographics.CustomerDesc = Nothing
                                      End If

                                      objCustomerDemographicsCol.Add(objCustomerDemographics)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCustomerDemographicsCol
         End Function

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As CustomerDemographicsCollection
              Dim objCustomerDemographicsCol As CustomerDemographicsCollection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCustomerDemographicsCol = New CustomerDemographicsCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objCustomerDemographics As CustomerDemographics = CreateCustomerDemographicsFromDataRowShared(dr)
                                      objCustomerDemographicsCol.Add(objCustomerDemographics)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCustomerDemographicsCol
         End Function

         ''' <summary>
         ''' Inserts a record
         ''' </summary>
         Public Shared Function Insert(objCustomerDemographics As CustomerDemographics) As String
             Return InsertUpdate(objCustomerDemographics, False)
         End Function

         ''' <summary>
         ''' Updates a record
         ''' </summary>
         Public Shared Sub Update(objCustomerDemographics As CustomerDemographics)
             InsertUpdate(objCustomerDemographics, True)
         End Sub

         Private Shared Function InsertUpdate(objCustomerDemographics As CustomerDemographics, isUpdate As Boolean) As String
              Dim newlyCreatedCustomerTypeID As String = objCustomerDemographics.CustomerTypeID

              Dim dynamicSqlScript As String = String.Empty

              If isUpdate Then
                  dynamicSqlScript = CustomerDemographicsSql.Update()
              Else
                  dynamicSqlScript = CustomerDemographicsSql.Insert()
              End If
              Dim customerDesc As Object = objCustomerDemographics.CustomerDesc

              If [String].IsNullOrEmpty(objCustomerDemographics.CustomerDesc) Then
                  customerDesc = System.DBNull.Value
              End If

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' parameters
                      command.Parameters.AddWithValue("@customerTypeID", objCustomerDemographics.CustomerTypeID)
                      command.Parameters.AddWithValue("@customerDesc", customerDesc)

                      If isUpdate Then
                          command.ExecuteNonQuery()
                      Else
                          newlyCreatedCustomerTypeID = DirectCast(command.ExecuteScalar(), String)
                      End If
                  End Using
              End Using

              Return newlyCreatedCustomerTypeID
         End Function

         ''' <summary>
         ''' Deletes a record based on primary key(s)
         ''' </summary>
         Public Shared Sub Delete(ByVal customerTypeID As String)
              Dim dynamicSqlScript As String = CustomerDemographicsSql.Delete()

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' parameters
                      command.Parameters.AddWithValue("@customerTypeID", customerTypeID)

                      ' execute
                      command.ExecuteNonQuery()
                  End Using
              End Using
         End Sub

         ''' <summary>
         ''' Adds search parameters to the Command object
         ''' </summary>
         Private Shared Sub AddSearchCommandParamsShared(command As SqlCommand, customerTypeID As String)
              If Not [String].IsNullOrEmpty(customerTypeID) Then
                  command.Parameters.AddWithValue("@customerTypeID", customerTypeID)
              Else
                  command.Parameters.AddWithValue("@customerTypeID", System.DBNull.Value)
              End If

         End Sub

         ''' <summary>
         ''' Creates a CustomerDemographics object from the passed data row
         ''' </summary>
         Private Shared Function CreateCustomerDemographicsFromDataRowShared(dr As DataRow) As CustomerDemographics
             Dim objCustomerDemographics As CustomerDemographics = New CustomerDemographics()


             If Not DbNull.Value.Equals(dr("CustomerTypeID")) Then
                 objCustomerDemographics.CustomerTypeID = dr("CustomerTypeID").ToString()
             Else
                 objCustomerDemographics.CustomerTypeID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("CustomerDesc")) Then
                 objCustomerDemographics.CustomerDesc = dr("CustomerDesc").ToString()
             Else
                 objCustomerDemographics.CustomerDesc = Nothing
             End If

             Return objCustomerDemographics
         End Function
     End Class
End Namespace
