Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class CategoriesSql
        Private Sub New() 
        End Sub 

        Public Shared Function SelectByPrimaryKey() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 
            sb.Append(" WHERE ") 
            sb.Append("[CategoryID] = @categoryID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Categories]")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCountDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Categories]")

            sb.Append(" WHERE ")
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ")
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CategoryID], ")
            sb.Append("[CategoryName], ")
            sb.Append("[Description] ")
            sb.Append("FROM [dbo].[Categories] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTakeDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ") 
            sb.Append("[CategoryID], ") 
            sb.Append("[CategoryName], ") 
            sb.Append("[Description] ") 
            sb.Append("FROM [dbo].[Categories] ") 
            sb.Append(" WHERE ")
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ")
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ")

            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAll() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAllDynamicWhere() As String
            Dim selectStatement As String = GetSelectStatement()
            Dim sb As New StringBuilder()

            sb.Append(selectStatement)
            sb.Append(" WHERE ")
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ")
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ")

            Return sb.ToString() 
        End Function

        ''' <summary>
        ''' Selects CategoryID and CategoryName columns for use with a DropDownList web control
        ''' </summary>
        Public Shared Function SelectCategoriesDropDownListData() As String
            Dim selectStatement As String = "SELECT [CategoryID], [CategoryName] FROM [dbo].[Categories] ORDER BY [CategoryName] ASC " 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement)

            Return sb.ToString() 
        End Function 

        Public Shared Function Insert() As String
            Dim sb As New StringBuilder() 

            sb.Append("INSERT INTO [dbo].[Categories] ") 
            sb.Append("(") 
            sb.Append("[CategoryName], ")
            sb.Append("[Description] ")
            sb.Append(") ") 
            sb.Append("OUTPUT inserted.[CategoryID] ") 
            sb.Append("VALUES ") 
            sb.Append("(") 
            sb.Append("@categoryName,")
            sb.Append("@description")
            sb.Append(")") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Update() As String
            Dim sb As New StringBuilder() 

            sb.Append("UPDATE [dbo].[Categories] ") 
            sb.Append("SET ") 
            sb.Append("[CategoryName] = @categoryName,")
            sb.Append("[Description] = @description")
            sb.Append(" WHERE ") 
            sb.Append("[CategoryID] = @categoryID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Delete() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DELETE FROM [dbo].[Categories] ") 
            sb.Append(" WHERE ") 
            sb.Append("[CategoryID] = @categoryID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CategoryID], ") 
            sb.Append("[CategoryName], ") 
            sb.Append("[Description] ") 
            sb.Append("FROM [dbo].[Categories] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
