Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class CustomerDemographicsSql
        Private Sub New() 
        End Sub 

        Public Shared Function SelectByPrimaryKey() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 
            sb.Append(" WHERE ") 
            sb.Append("[CustomerTypeID] = @customerTypeID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[CustomerDemographics]")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCountDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[CustomerDemographics]")

            sb.Append(" WHERE ")
            sb.Append("([CustomerTypeID] LIKE '%' + @customerTypeID + '%' OR @customerTypeID IS NULL) ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CustomerTypeID], ")
            sb.Append("[CustomerDesc] ")
            sb.Append("FROM [dbo].[CustomerDemographics] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerTypeID' THEN [CustomerTypeID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerTypeID desc' THEN [CustomerTypeID] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTakeDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ") 
            sb.Append("[CustomerTypeID], ") 
            sb.Append("[CustomerDesc] ") 
            sb.Append("FROM [dbo].[CustomerDemographics] ") 
            sb.Append(" WHERE ")
            sb.Append("([CustomerTypeID] LIKE '%' + @customerTypeID + '%' OR @customerTypeID IS NULL) ")

            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerTypeID' THEN [CustomerTypeID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerTypeID desc' THEN [CustomerTypeID] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAll() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAllDynamicWhere() As String
            Dim selectStatement As String = GetSelectStatement()
            Dim sb As New StringBuilder()

            sb.Append(selectStatement)
            sb.Append(" WHERE ")
            sb.Append("([CustomerTypeID] LIKE '%' + @customerTypeID + '%' OR @customerTypeID IS NULL) ")

            Return sb.ToString() 
        End Function

        ''' <summary>
        ''' Selects CustomerTypeID and CustomerDesc columns for use with a DropDownList web control
        ''' </summary>
        Public Shared Function SelectCustomerDemographicsDropDownListData() As String
            Dim selectStatement As String = "SELECT [CustomerTypeID], [CustomerDesc] FROM [dbo].[CustomerDemographics] ORDER BY [CustomerDesc] ASC " 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement)

            Return sb.ToString() 
        End Function 

        Public Shared Function Insert() As String
            Dim sb As New StringBuilder() 

            sb.Append("INSERT INTO [dbo].[CustomerDemographics] ") 
            sb.Append("(") 
            sb.Append("[CustomerTypeID], ")
            sb.Append("[CustomerDesc] ")
            sb.Append(") ") 
            sb.Append("OUTPUT inserted.[CustomerTypeID] ") 
            sb.Append("VALUES ") 
            sb.Append("(") 
            sb.Append("@customerTypeID,")
            sb.Append("@customerDesc")
            sb.Append(")") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Update() As String
            Dim sb As New StringBuilder() 

            sb.Append("UPDATE [dbo].[CustomerDemographics] ") 
            sb.Append("SET ") 
            sb.Append("[CustomerTypeID] = @customerTypeID,")
            sb.Append("[CustomerDesc] = @customerDesc")
            sb.Append(" WHERE ") 
            sb.Append("[CustomerTypeID] = @customerTypeID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Delete() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DELETE FROM [dbo].[CustomerDemographics] ") 
            sb.Append(" WHERE ") 
            sb.Append("[CustomerTypeID] = @customerTypeID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CustomerTypeID], ") 
            sb.Append("[CustomerDesc] ") 
            sb.Append("FROM [dbo].[CustomerDemographics] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
