Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class CustomersSql
        Private Sub New() 
        End Sub 

        Public Shared Function SelectByPrimaryKey() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 
            sb.Append(" WHERE ") 
            sb.Append("[CustomerID] = @customerID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Customers]")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetRecordCountDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Customers]")

            sb.Append(" WHERE ")
            sb.Append("([CustomerID] LIKE '%' + @customerID + '%' OR @customerID IS NULL) AND ")
            sb.Append("([CompanyName] LIKE '%' + @companyName + '%' OR @companyName IS NULL) AND ")
            sb.Append("([ContactName] LIKE '%' + @contactName + '%' OR @contactName IS NULL) AND ")
            sb.Append("([ContactTitle] LIKE '%' + @contactTitle + '%' OR @contactTitle IS NULL) AND ")
            sb.Append("([Address] LIKE '%' + @address + '%' OR @address IS NULL) AND ")
            sb.Append("([City] LIKE '%' + @city + '%' OR @city IS NULL) AND ")
            sb.Append("([Region] LIKE '%' + @region1 + '%' OR @region1 IS NULL) AND ")
            sb.Append("([PostalCode] LIKE '%' + @postalCode + '%' OR @postalCode IS NULL) AND ")
            sb.Append("([Country] LIKE '%' + @country + '%' OR @country IS NULL) AND ")
            sb.Append("([Phone] LIKE '%' + @phone + '%' OR @phone IS NULL) AND ")
            sb.Append("([Fax] LIKE '%' + @fax + '%' OR @fax IS NULL) ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CustomerID], ")
            sb.Append("[CompanyName], ")
            sb.Append("[ContactName], ")
            sb.Append("[ContactTitle], ")
            sb.Append("[Address], ")
            sb.Append("[City], ")
            sb.Append("[Region] AS [Region1], ")
            sb.Append("[PostalCode], ")
            sb.Append("[Country], ")
            sb.Append("[Phone], ")
            sb.Append("[Fax] ")
            sb.Append("FROM [dbo].[Customers] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ContactName' THEN [ContactName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ContactName desc' THEN [ContactName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ContactTitle' THEN [ContactTitle] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ContactTitle desc' THEN [ContactTitle] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Address' THEN [Address] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Address desc' THEN [Address] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Region1' THEN [Region] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Region1 desc' THEN [Region] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode' THEN [PostalCode] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode desc' THEN [PostalCode] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Phone' THEN [Phone] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Phone desc' THEN [Phone] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Fax' THEN [Fax] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Fax desc' THEN [Fax] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTakeDynamicWhere() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ") 
            sb.Append("[CustomerID], ") 
            sb.Append("[CompanyName], ") 
            sb.Append("[ContactName], ") 
            sb.Append("[ContactTitle], ") 
            sb.Append("[Address], ") 
            sb.Append("[City], ") 
            sb.Append("[Region] AS [Region1], ") 
            sb.Append("[PostalCode], ") 
            sb.Append("[Country], ") 
            sb.Append("[Phone], ") 
            sb.Append("[Fax] ") 
            sb.Append("FROM [dbo].[Customers] ") 
            sb.Append(" WHERE ")
            sb.Append("([CustomerID] LIKE '%' + @customerID + '%' OR @customerID IS NULL) AND ")
            sb.Append("([CompanyName] LIKE '%' + @companyName + '%' OR @companyName IS NULL) AND ")
            sb.Append("([ContactName] LIKE '%' + @contactName + '%' OR @contactName IS NULL) AND ")
            sb.Append("([ContactTitle] LIKE '%' + @contactTitle + '%' OR @contactTitle IS NULL) AND ")
            sb.Append("([Address] LIKE '%' + @address + '%' OR @address IS NULL) AND ")
            sb.Append("([City] LIKE '%' + @city + '%' OR @city IS NULL) AND ")
            sb.Append("([Region] LIKE '%' + @region1 + '%' OR @region1 IS NULL) AND ")
            sb.Append("([PostalCode] LIKE '%' + @postalCode + '%' OR @postalCode IS NULL) AND ")
            sb.Append("([Country] LIKE '%' + @country + '%' OR @country IS NULL) AND ")
            sb.Append("([Phone] LIKE '%' + @phone + '%' OR @phone IS NULL) AND ")
            sb.Append("([Fax] LIKE '%' + @fax + '%' OR @fax IS NULL) ")

            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName' THEN [CompanyName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CompanyName desc' THEN [CompanyName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ContactName' THEN [ContactName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ContactName desc' THEN [ContactName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ContactTitle' THEN [ContactTitle] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ContactTitle desc' THEN [ContactTitle] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Address' THEN [Address] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Address desc' THEN [Address] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Region1' THEN [Region] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Region1 desc' THEN [Region] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode' THEN [PostalCode] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode desc' THEN [PostalCode] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Phone' THEN [Phone] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Phone desc' THEN [Phone] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Fax' THEN [Fax] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Fax desc' THEN [Fax] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAll() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement) 

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectAllDynamicWhere() As String
            Dim selectStatement As String = GetSelectStatement()
            Dim sb As New StringBuilder()

            sb.Append(selectStatement)
            sb.Append(" WHERE ")
            sb.Append("([CustomerID] LIKE '%' + @customerID + '%' OR @customerID IS NULL) AND ")
            sb.Append("([CompanyName] LIKE '%' + @companyName + '%' OR @companyName IS NULL) AND ")
            sb.Append("([ContactName] LIKE '%' + @contactName + '%' OR @contactName IS NULL) AND ")
            sb.Append("([ContactTitle] LIKE '%' + @contactTitle + '%' OR @contactTitle IS NULL) AND ")
            sb.Append("([Address] LIKE '%' + @address + '%' OR @address IS NULL) AND ")
            sb.Append("([City] LIKE '%' + @city + '%' OR @city IS NULL) AND ")
            sb.Append("([Region] LIKE '%' + @region1 + '%' OR @region1 IS NULL) AND ")
            sb.Append("([PostalCode] LIKE '%' + @postalCode + '%' OR @postalCode IS NULL) AND ")
            sb.Append("([Country] LIKE '%' + @country + '%' OR @country IS NULL) AND ")
            sb.Append("([Phone] LIKE '%' + @phone + '%' OR @phone IS NULL) AND ")
            sb.Append("([Fax] LIKE '%' + @fax + '%' OR @fax IS NULL) ")

            Return sb.ToString() 
        End Function

        ''' <summary>
        ''' Selects CustomerID and CompanyName columns for use with a DropDownList web control
        ''' </summary>
        Public Shared Function SelectCustomersDropDownListData() As String
            Dim selectStatement As String = "SELECT [CustomerID], [CompanyName] FROM [dbo].[Customers] ORDER BY [CompanyName] ASC " 
            Dim sb As New StringBuilder() 

            sb.Append(selectStatement)

            Return sb.ToString() 
        End Function 

        Public Shared Function Insert() As String
            Dim sb As New StringBuilder() 

            sb.Append("INSERT INTO [dbo].[Customers] ") 
            sb.Append("(") 
            sb.Append("[CustomerID], ")
            sb.Append("[CompanyName], ")
            sb.Append("[ContactName], ")
            sb.Append("[ContactTitle], ")
            sb.Append("[Address], ")
            sb.Append("[City], ")
            sb.Append("[Region], ")
            sb.Append("[PostalCode], ")
            sb.Append("[Country], ")
            sb.Append("[Phone], ")
            sb.Append("[Fax] ")
            sb.Append(") ") 
            sb.Append("OUTPUT inserted.[CustomerID] ") 
            sb.Append("VALUES ") 
            sb.Append("(") 
            sb.Append("@customerID,")
            sb.Append("@companyName,")
            sb.Append("@contactName,")
            sb.Append("@contactTitle,")
            sb.Append("@address,")
            sb.Append("@city,")
            sb.Append("@region1,")
            sb.Append("@postalCode,")
            sb.Append("@country,")
            sb.Append("@phone,")
            sb.Append("@fax")
            sb.Append(")") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Update() As String
            Dim sb As New StringBuilder() 

            sb.Append("UPDATE [dbo].[Customers] ") 
            sb.Append("SET ") 
            sb.Append("[CustomerID] = @customerID,")
            sb.Append("[CompanyName] = @companyName,")
            sb.Append("[ContactName] = @contactName,")
            sb.Append("[ContactTitle] = @contactTitle,")
            sb.Append("[Address] = @address,")
            sb.Append("[City] = @city,")
            sb.Append("[Region] = @region1,")
            sb.Append("[PostalCode] = @postalCode,")
            sb.Append("[Country] = @country,")
            sb.Append("[Phone] = @phone,")
            sb.Append("[Fax] = @fax")
            sb.Append(" WHERE ") 
            sb.Append("[CustomerID] = @customerID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function Delete() As String 
            Dim sb As New StringBuilder() 

            sb.Append("DELETE FROM [dbo].[Customers] ") 
            sb.Append(" WHERE ") 
            sb.Append("[CustomerID] = @customerID ") 

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CustomerID], ") 
            sb.Append("[CompanyName], ") 
            sb.Append("[ContactName], ") 
            sb.Append("[ContactTitle], ") 
            sb.Append("[Address], ") 
            sb.Append("[City], ") 
            sb.Append("[Region] AS [Region1], ") 
            sb.Append("[PostalCode], ") 
            sb.Append("[Country], ") 
            sb.Append("[Phone], ") 
            sb.Append("[Fax] ") 
            sb.Append("FROM [dbo].[Customers] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
