Imports System
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class ListInlineEmployees
        Dim _currentRecordNumber As Integer = 1
        Dim _currentPageNumber As Integer = 1
        Dim _totalRecords As Integer = 0
        Dim _totalNumberOfPages As Integer = 0
        Dim _sortColumnIndex As Integer = 0
        Dim _sortByExpression As String = "EmployeeID"
        Dim _sortOrder As SortOrder = SortOrder.Ascending
        Dim _currentRowIndex As Integer
        Dim _isFireToolStripComboBoxSelectedIndexChanged As Boolean

        #Region "winform events"

        Private Sub ListInlineEmployees_Load(sender As Object, e As EventArgs) Handles MyBase.Load
            SetGridProperties()
            SetGridColumnProperties()
            FillGridComboBoxColumns()
            SetDataSource(False)
            ResetNavButtonsToDefault()

            BnvNavAddNewItem.Enabled = True
        End Sub

        #End Region

        #Region "binding navigator control events"

        Private Sub BnvNavMoveFirstItem_Click(sender As Object, e As EventArgs) Handles BnvNavMoveFirstItem.Click
            _currentRecordNumber = 1
            _currentPageNumber = 1
            MoveToFirstPage()
        End Sub

        Private Sub BnvNavMovePreviousItem_Click(sender As Object, e As EventArgs) Handles BnvNavMovePreviousItem.Click
            _currentPageNumber -= 1
            _currentRecordNumber = 1 + (ConstantHelper.GridNumberOfRows * (_currentPageNumber - 1))

            MoveToPrevious()
        End Sub

        Private Sub BnvNavMoveNextItem_Click(sender As Object, e As EventArgs) Handles BnvNavMoveNextItem.Click
            _currentPageNumber += 1
            _currentRecordNumber = 1 + (ConstantHelper.GridNumberOfRows * (_currentPageNumber - 1))

            MoveToNext()
        End Sub

        Private Sub BnvNavMoveLastItem_Click(sender As Object, e As EventArgs) Handles BnvNavMoveLastItem.Click
            _currentPageNumber = _totalNumberOfPages
            _currentRecordNumber = 1 + (ConstantHelper.GridNumberOfRows * (_currentPageNumber - 1))

            MoveToLastPage()
        End Sub

        Private Sub BnvNavAddNewItem_Click(sender As Object, e As EventArgs) Handles BnvNavAddNewItem.Click
            ' add just the required fields
            Dim objEmployees As New Employees()
            objEmployees.LastName = String.Empty
            objEmployees.FirstName = String.Empty

            objEmployees.Insert()

            _currentRecordNumber = 1
            _currentPageNumber = 1
            _sortColumnIndex = 0
            _sortByExpression = "EmployeeID"

            SetDataSource(True)

            ' focus on the first text box
            DgvGrid.Focus()
            DgvGrid.CurrentCell = DgvGrid.Rows(0).Cells("LastName")
        End Sub

        #End Region

        #Region "data gridview events"

        Private Sub DgvGrid_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DgvGrid.ColumnHeaderMouseClick
            _sortColumnIndex = e.ColumnIndex
            SetDataSource(True)
        End Sub

        Private Sub DgvGrid_DataError(sender As Object, e As DataGridViewDataErrorEventArgs) Handles DgvGrid.DataError
            e.ThrowException = False
            e.Cancel = False
        End Sub

        Private Sub DgvGrid_RowLeave(sender As Object, e As DataGridViewCellEventArgs) Handles DgvGrid.RowLeave
            If DgvGrid.IsCurrentRowDirty Then
                If IsChangesValid(e.RowIndex)
                Dim employeeID As Integer
                Dim lastName As String = Nothing
                Dim firstName As String = Nothing
                Dim title As String = Nothing
                Dim titleOfCourtesy As String = Nothing
                Dim birthDate As Date? = DateTime.MinValue
                Dim hireDate As Date? = DateTime.MinValue
                Dim address As String = Nothing
                Dim city As String = Nothing
                Dim region1 As String = Nothing
                Dim postalCode As String = Nothing
                Dim country As String = Nothing
                Dim homePhone As String = Nothing
                Dim extension As String = Nothing
                Dim notes As String = Nothing
                Dim reportsTo As Integer? = Nothing
                Dim photoPath As String = Nothing

                employeeID = Convert.ToInt32(DgvGrid.Rows(e.RowIndex).Cells("EmployeeID").Value.ToString())

                If DgvGrid.Rows(e.RowIndex).Cells("LastName").Value IsNot Nothing Then
                    lastName = DgvGrid.Rows(e.RowIndex).Cells("LastName").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("FirstName").Value IsNot Nothing Then
                    firstName = DgvGrid.Rows(e.RowIndex).Cells("FirstName").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Title").Value IsNot Nothing Then
                    title = DgvGrid.Rows(e.RowIndex).Cells("Title").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("TitleOfCourtesy").Value IsNot Nothing Then
                    titleOfCourtesy = DgvGrid.Rows(e.RowIndex).Cells("TitleOfCourtesy").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("BirthDate").Value IsNot Nothing Then
                    birthDate = Convert.ToDateTime(DgvGrid.Rows(e.RowIndex).Cells("BirthDate").Value.ToString())
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("HireDate").Value IsNot Nothing Then
                    hireDate = Convert.ToDateTime(DgvGrid.Rows(e.RowIndex).Cells("HireDate").Value.ToString())
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Address").Value IsNot Nothing Then
                    address = DgvGrid.Rows(e.RowIndex).Cells("Address").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("City").Value IsNot Nothing Then
                    city = DgvGrid.Rows(e.RowIndex).Cells("City").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Region1").Value IsNot Nothing Then
                    region1 = DgvGrid.Rows(e.RowIndex).Cells("Region1").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("PostalCode").Value IsNot Nothing Then
                    postalCode = DgvGrid.Rows(e.RowIndex).Cells("PostalCode").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Country").Value IsNot Nothing Then
                    country = DgvGrid.Rows(e.RowIndex).Cells("Country").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("HomePhone").Value IsNot Nothing Then
                    homePhone = DgvGrid.Rows(e.RowIndex).Cells("HomePhone").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Extension").Value IsNot Nothing Then
                    extension = DgvGrid.Rows(e.RowIndex).Cells("Extension").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("Notes").Value IsNot Nothing Then
                    notes = DgvGrid.Rows(e.RowIndex).Cells("Notes").Value.ToString()
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("ReportsTo").Value IsNot Nothing Then
                    reportsTo = Convert.ToInt32(DgvGrid.Rows(e.RowIndex).Cells("ReportsTo").Value.ToString())
                End If

                If DgvGrid.Rows(e.RowIndex).Cells("PhotoPath").Value IsNot Nothing Then
                    photoPath = DgvGrid.Rows(e.RowIndex).Cells("PhotoPath").Value.ToString()
                End If

                    Dim objEmployees As Employees = Employees.SelectByPrimaryKey(employeeID)
                objEmployees.EmployeeID = employeeID
                objEmployees.LastName = lastName
                objEmployees.FirstName = firstName
                objEmployees.Title = title
                objEmployees.TitleOfCourtesy = titleOfCourtesy
                objEmployees.BirthDate = birthDate.Value
                objEmployees.HireDate = hireDate.Value
                objEmployees.Address = address
                objEmployees.City = city
                objEmployees.Region1 = region1
                objEmployees.PostalCode = postalCode
                objEmployees.Country = country
                objEmployees.HomePhone = homePhone
                objEmployees.Extension = extension
                objEmployees.Notes = notes
                objEmployees.ReportsTo = reportsTo.Value
                objEmployees.PhotoPath = photoPath

                    objEmployees.Update()
                End If
            End If
        End Sub

        #End Region

        #Region "toolstrip menu item events"

        Private Sub TscbPage_SelectedIndexChanged(sender As Object, e As EventArgs) Handles TscbPage.SelectedIndexChanged
            ' make sure this event is not called 
            ' when adding items to the tool strip combo box
            If Not _isFireToolStripComboBoxSelectedIndexChanged Then
                Return
            End If

            ' set current page number
            Dim lastVisitedPageNumber As Integer = _currentPageNumber
            _currentPageNumber = Cint(TscbPage.ComboBox.SelectedItem)

            If _currentPageNumber = 1 Then
                _currentRecordNumber = 1
            Else
                _currentRecordNumber = 1 + (ConstantHelper.GridNumberOfRows * (_currentPageNumber - 1))
            End If

            ' go to the selected page
            If _currentPageNumber = 1 Then
                MoveToFirstPage()
            Else If _currentPageNumber = _totalNumberOfPages Then
                MoveToLastPage()
            Else If _currentPageNumber < lastVisitedPageNumber Then
                MoveToPrevious()
            Else
                MoveToNext()
            End If
        End Sub

        #End Region

        #Region "private methods"

        Private Sub FillGridComboBoxColumns()
            ' fill ReportsToGridColumn datagridview combo box column
            Dim objEmployeesCol1 As New EmployeesCollection()
            objEmployeesCol1.Add(New Employees With { .EmployeeID = -1, .LastName = "" })
            objEmployeesCol1.AddRange(Employees.SelectEmployeesDropDownListData())

            ReportsToGridColumn.DataSource = objEmployeesCol1
            ReportsToGridColumn.ValueMember = "EmployeeID"
            ReportsToGridColumn.DisplayMember = "LastName"

        End Sub

        Private Function IsChangesValid(rowIndex As Integer) As Boolean
            Dim errors As String = String.Empty
            DgvGrid.CommitEdit(DataGridViewDataErrorContexts.Commit)

            If DgvGrid.Rows(rowIndex).Cells("LastName").Value Is Nothing Then
                errors += "Last Name is required!\n\r"
            End If

            If DgvGrid.Rows(rowIndex).Cells("FirstName").Value Is Nothing Then
                errors += "First Name is required!\n\r"
            End If

            If Not String.IsNullOrEmpty(errors) Then
                MessageBox.Show(errors, "An Error Occured")
                Return False
            End If

            Return True
        End Function

        Private Sub SetGridProperties()
            DgvGrid.AutoGenerateColumns = False
            DgvGrid.AllowUserToResizeRows = False
            DgvGrid.ColumnCount = 17
            DgvGrid.ScrollBars = ScrollBars.Horizontal
            DgvGrid.AllowUserToOrderColumns = False
        End Sub

        Private Sub SetGridColumnProperties()
            DgvGrid.Columns("EmployeeID").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvGrid.Columns("LastName").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("FirstName").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("Title").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("TitleOfCourtesy").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("BirthDate").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvGrid.Columns("HireDate").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvGrid.Columns("Address").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("City").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("Region1").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("PostalCode").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("Country").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("HomePhone").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("Extension").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("Notes").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvGrid.Columns("ReportsTo").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvGrid.Columns("PhotoPath").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
        End Sub

        Private Sub MoveToFirstPage()
            SetDataSource(False)
            ToolStripHelper.MoveToFirst(BnvNavMoveFirstItem, BnvNavMovePreviousItem, BnvNavMoveNextItem, BnvNavMoveLastItem)
        End Sub

        Private Sub MoveToPrevious()
            SetDataSource(False)
            ToolStripHelper.MoveToPrevious(BnvNavMoveFirstItem, BnvNavMovePreviousItem, BnvNavMoveNextItem, BnvNavMoveLastItem, _currentRecordNumber)
        End Sub

        Private Sub MoveToNext()
            SetDataSource(False)
            ToolStripHelper.MoveToNext(BnvNavMoveFirstItem, BnvNavMovePreviousItem, BnvNavMoveNextItem, BnvNavMoveLastItem, _currentPageNumber, _totalNumberOfPages)
        End Sub

        Private Sub MoveToLastPage()
            SetDataSource(False)
            ToolStripHelper.MoveToLast(BnvNavMoveFirstItem, BnvNavMovePreviousItem, BnvNavMoveNextItem, BnvNavMoveLastItem)
        End Sub

        Private Sub SetDataSource(isSort As Boolean)
            If isSort Then
                _sortByExpression = GetSortByExpression()
            End If

            ' fill the datagridview
            DgvGrid.DataSource = Employees.SelectSkipAndTake(ConstantHelper.GridNumberOfRows, _currentRecordNumber, _totalRecords, _sortByExpression)
            DgvGrid.Columns(_sortColumnIndex).HeaderCell.SortGlyphDirection = _sortOrder

            If _totalRecords > 0 Then
                _totalNumberOfPages = CInt(Math.Ceiling(CSng(_totalRecords) / CSng(ConstantHelper.GridNumberOfRows)))
                TscbPage.ComboBox.Items.Clear()

                ' fill page numbers in toolstripcombobox
                For page As Integer = 1 To _totalNumberOfPages
                    _isFireToolStripComboBoxSelectedIndexChanged = False
                    TscbPage.ComboBox.Items.Add(page)
                Next

                TscbPage.ComboBox.SelectedItem = _currentPageNumber
                _isFireToolStripComboBoxSelectedIndexChanged = True
            End If

            ResetNavButtonsToDefault()
        End Sub

        Private Function GetSortByExpression() As String
            _sortOrder = SortOrder.Descending

            Select Case _sortColumnIndex
                Case 0
                    If _sortByExpression = "EmployeeID" Then
                        Return "EmployeeID desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "EmployeeID"

                Case 1
                    If _sortByExpression = "LastName" Then
                        Return "LastName desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "LastName"

                Case 2
                    If _sortByExpression = "FirstName" Then
                        Return "FirstName desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "FirstName"

                Case 3
                    If _sortByExpression = "Title" Then
                        Return "Title desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Title"

                Case 4
                    If _sortByExpression = "TitleOfCourtesy" Then
                        Return "TitleOfCourtesy desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "TitleOfCourtesy"

                Case 5
                    If _sortByExpression = "BirthDate" Then
                        Return "BirthDate desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "BirthDate"

                Case 6
                    If _sortByExpression = "HireDate" Then
                        Return "HireDate desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "HireDate"

                Case 7
                    If _sortByExpression = "Address" Then
                        Return "Address desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Address"

                Case 8
                    If _sortByExpression = "City" Then
                        Return "City desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "City"

                Case 9
                    If _sortByExpression = "Region1" Then
                        Return "Region1 desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Region1"

                Case 10
                    If _sortByExpression = "PostalCode" Then
                        Return "PostalCode desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "PostalCode"

                Case 11
                    If _sortByExpression = "Country" Then
                        Return "Country desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Country"

                Case 12
                    If _sortByExpression = "HomePhone" Then
                        Return "HomePhone desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "HomePhone"

                Case 13
                    If _sortByExpression = "Extension" Then
                        Return "Extension desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Extension"

                Case 14
                    If _sortByExpression = "Notes" Then
                        Return "Notes desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "Notes"

                Case 15
                    If _sortByExpression = "ReportsTo" Then
                        Return "ReportsTo desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "ReportsTo"

                Case 16
                    If _sortByExpression = "PhotoPath" Then
                        Return "PhotoPath desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "PhotoPath"

                Case Else
                    If _sortByExpression = "EmployeeID" Then
                        Return "EmployeeID desc"
                    End If

                    _sortOrder = SortOrder.Ascending
                    Return "EmployeeID"
            End Select
        End Function

        Private Sub ResetNavButtonsToDefault()
            BnvNavCountItem.Text = "of " & _totalNumberOfPages & " pages"

            If _totalRecords <= ConstantHelper.GridNumberOfRows Then
                BnvNavMoveNextItem.Enabled = False
                BnvNavMoveLastItem.Enabled = False
            Else
                BnvNavMoveNextItem.Enabled = True
                BnvNavMoveLastItem.Enabled = True
            End If
        End Sub

        Private Sub HightlightRow(rowIndex As Integer)
            ' highlight row
            DgvGrid.ClearSelection()
            DgvGrid.Rows(rowIndex).Selected = True

            ' remember the current row clicked by the user
            _currentRowIndex = rowIndex
        End Sub

        Private Sub DeleteItem()
            Dim employeeID1 As Integer = Convert.ToInt32(DgvGrid.Rows(_currentRowIndex).Cells("EmployeeID").Value.ToString())
            Dim result As DialogResult = MessageBox.Show("Are you sure you want to delete item: " & employeeID1 & "?", "Confirm Item Deletion", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation)

            If result = DialogResult.OK Then
                ' delete item
                Employees.Delete(employeeID1)

                SetDataSource(False)
            End If
        End Sub

        #End Region
    End Class
