Imports System
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class ListMasterDetailGridProductsBySupplierID
        ' details variables (Products)
        Const _gridDetailsNumberOfRows As Integer = 15
        Dim _currentDetailsRecordNumber As Integer = 1
        Dim _currentDetailsPageNumber As Integer = 1
        Dim _totalDetailsRecords As Integer = 0
        Dim _totalDetailsNumberOfPages As Integer = 0
        Dim _sortDetailsColumnIndex As Integer = 0
        Dim _sortDetailsByExpression As String = "ProductID"
        Dim _sortDetailsOrder As SortOrder = SortOrder.Ascending
        Dim _currentDetailsRowIndex As Integer
        Dim _isDetailsFireToolStripComboBoxSelectedIndexChanged As Boolean

        ' master variables (Suppliers)
        Dim _supplierID1 As Integer
        Const _gridMasterNumberOfRows As Integer = 5
        Dim _currentMasterRecordNumber As Integer = 1
        Dim _currentMasterPageNumber As Integer = 1
        Dim _totalMasterRecords As Integer = 0
        Dim _totalMasterNumberOfPages As Integer = 0
        Dim _sortMasterColumnIndex As Integer = 0
        Dim _sortMasterByExpression As String = "SupplierID"
        Dim _sortMasterOrder As SortOrder = SortOrder.Ascending
        Dim _currentMasterRowIndex As Integer
        Dim _isMasterFireToolStripComboBoxSelectedIndexChanged As Boolean

        #Region "winform events"

        Private Sub ListMasterDetailGridProductsBySupplierID_Load(sender As Object, e As EventArgs) Handles MyBase.Load
            SetMasterGridProperties()
            SetMasterGridColumnProperties()
            SetMasterDataSource(False)

            SetDetailsGridProperties()
            SetDetailsGridColumnProperties()

            LblLine.Width = Me.Width

            HightlightMasterRow(0)
        End Sub

        Private Sub ListMasterDetailGridProductsBySupplierID_Resize(sender As Object, e As EventArgs) Handles MyBase.Resize
            LblLine.Width = Me.Width
        End Sub

        #End Region

        #Region "binding navigator control events"

        Private Sub BnvDetailsNavMoveFirstItem_Click(sender As Object, e As EventArgs) Handles BnvDetailsNavMoveFirstItem.Click
            _currentDetailsRecordNumber = 1
            _currentDetailsPageNumber = 1
            MoveDetailsToFirstPage()
        End Sub

        Private Sub BnvDetailsNavMovePreviousItem_Click(sender As Object, e As EventArgs) Handles BnvDetailsNavMovePreviousItem.Click
            _currentDetailsPageNumber -= 1
            _currentDetailsRecordNumber = 1 + (_gridDetailsNumberOfRows * (_currentDetailsPageNumber - 1))

            MoveDetailsToPrevious()
        End Sub

        Private Sub BnvDetailsNavMoveNextItem_Click(sender As Object, e As EventArgs) Handles BnvDetailsNavMoveNextItem.Click
            _currentDetailsPageNumber += 1
            _currentDetailsRecordNumber = 1 + (_gridDetailsNumberOfRows * (_currentDetailsPageNumber - 1))

            MoveDetailsToNext()
        End Sub

        Private Sub BnvDetailsNavMoveLastItem_Click(sender As Object, e As EventArgs) Handles BnvDetailsNavMoveLastItem.Click
            _currentDetailsPageNumber = _totalDetailsNumberOfPages
            _currentDetailsRecordNumber = 1 + (_gridDetailsNumberOfRows * (_currentDetailsPageNumber - 1))

            MoveDetailsToLastPage()
        End Sub

        Private Sub BnvMasterNavMoveFirstItem_Click(sender As Object, e As EventArgs) Handles BnvMasterNavMoveFirstItem.Click
            _currentMasterRecordNumber = 1
            _currentMasterPageNumber = 1
            MoveMasterToFirstPage()
        End Sub

        Private Sub BnvMasterNavMovePreviousItem_Click(sender As Object, e As EventArgs) Handles BnvMasterNavMovePreviousItem.Click
            _currentMasterPageNumber -= 1
            _currentMasterRecordNumber = 1 + (_gridMasterNumberOfRows * (_currentMasterPageNumber - 1))

            MoveMasterToPrevious()
        End Sub

        Private Sub BnvMasterNavMoveNextItem_Click(sender As Object, e As EventArgs) Handles BnvMasterNavMoveNextItem.Click
            _currentMasterPageNumber += 1
            _currentMasterRecordNumber = 1 + (_gridMasterNumberOfRows * (_currentMasterPageNumber - 1))

            MoveMasterToNext()
        End Sub

        Private Sub BnvMasterNavMoveLastItem_Click(sender As Object, e As EventArgs) Handles BnvMasterNavMoveLastItem.Click
            _currentMasterPageNumber = _totalMasterNumberOfPages
            _currentMasterRecordNumber = 1 + (_gridMasterNumberOfRows * (_currentMasterPageNumber - 1))

            MoveMasterToLastPage()
        End Sub


        #End Region

        #Region "data gridview events"

        Private Sub DgvDetailsGrid_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DgvDetailsGrid.ColumnHeaderMouseClick
            _sortDetailsColumnIndex = e.ColumnIndex
            SetDetailsDataSource(True)
        End Sub

        Private Sub DgvMasterGrid_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DgvMasterGrid.ColumnHeaderMouseClick
            _sortMasterColumnIndex = e.ColumnIndex
            SetMasterDataSource(True)
            HightlightMasterRow(0)
        End Sub

        Private Sub DgvDetailsGrid_CellContextMenuStripNeeded(sender As Object, e As DataGridViewCellContextMenuStripNeededEventArgs) Handles DgvDetailsGrid.CellContextMenuStripNeeded
            HightlightDetailsRow(e.RowIndex)
        End Sub

        Private Sub DgvDetailsGrid_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DgvDetailsGrid.CellClick
            ' make sure the click did not come from the header
            If e.RowIndex <> -1 Then
                HightlightDetailsRow(e.RowIndex)
            End If
        End Sub

        Private Sub DgvMasterGrid_CellContextMenuStripNeeded(sender As Object, e As DataGridViewCellContextMenuStripNeededEventArgs) Handles DgvMasterGrid.CellContextMenuStripNeeded
            HightlightMasterRow(e.RowIndex)
        End Sub

        Private Sub DgvMasterGrid_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DgvMasterGrid.CellClick
            ' make sure the click did not come from the header
            If e.RowIndex <> -1 Then
                HightlightMasterRow(e.RowIndex)
            End If
        End Sub

        Private Sub DgvDetailsGrid_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles DgvDetailsGrid.CellContentClick
            If e.ColumnIndex = 2  And e.RowIndex <> -1 Then
                Dim supplierID As Integer = Convert.ToInt32(DgvDetailsGrid.Rows(e.RowIndex).Cells("SupplierID").Value.ToString())

                Dim form As New DetailsSuppliers(supplierID)
                form.ShowDialog()
            End If
            If e.ColumnIndex = 3  And e.RowIndex <> -1 Then
                Dim categoryID As Integer = Convert.ToInt32(DgvDetailsGrid.Rows(e.RowIndex).Cells("CategoryID").Value.ToString())

                Dim form As New DetailsCategories(categoryID)
                form.ShowDialog()
            End If
        End Sub

        #End Region

        #Region "toolstrip menu item events"

        Private Sub TscbDetailsPage_SelectedIndexChanged(sender As Object, e As EventArgs) Handles TscbDetailsPage.SelectedIndexChanged
            ' make sure this event is not called 
            ' when adding items to the tool strip combo box
            If Not _isDetailsFireToolStripComboBoxSelectedIndexChanged Then
                Return
            End If

            ' set current page number
            Dim lastVisitedPageNumber As Integer = _currentDetailsPageNumber
            _currentDetailsPageNumber = Cint(TscbDetailsPage.ComboBox.SelectedItem)

            If _currentDetailsPageNumber = 1 Then
                _currentDetailsRecordNumber = 1
            Else
                _currentDetailsRecordNumber = 1 + (_gridDetailsNumberOfRows * (_currentDetailsPageNumber - 1))
            End If

            ' go to the selected page
            If _currentDetailsPageNumber = 1 Then
                MoveDetailsToFirstPage()
            Else If _currentDetailsPageNumber = _totalDetailsNumberOfPages Then
                MoveDetailsToLastPage()
            Else If _currentDetailsPageNumber < lastVisitedPageNumber Then
                MoveDetailsToPrevious()
            Else
                MoveDetailsToNext()
            End If
        End Sub

        Private Sub TscbMasterPage_SelectedIndexChanged(sender As Object, e As EventArgs) Handles TscbMasterPage.SelectedIndexChanged
            ' make sure this event is not called 
            ' when adding items to the tool strip combo box
            If Not _isMasterFireToolStripComboBoxSelectedIndexChanged Then
                Return
            End If

            ' set current page number
            Dim lastVisitedPageNumber As Integer = _currentMasterPageNumber
            _currentMasterPageNumber = Cint(TscbMasterPage.ComboBox.SelectedItem)

            If _currentMasterPageNumber = 1 Then
                _currentMasterRecordNumber = 1
            Else
                _currentMasterRecordNumber = 1 + (_gridMasterNumberOfRows * (_currentMasterPageNumber - 1))
            End If

            ' go to the selected page
            If _currentMasterPageNumber = 1 Then
                MoveMasterToFirstPage()
            Else If _currentMasterPageNumber = _totalMasterNumberOfPages Then
                MoveMasterToLastPage()
            Else If _currentMasterPageNumber < lastVisitedPageNumber Then
                MoveMasterToPrevious()
            Else
                MoveMasterToNext()
            End If
        End Sub

        #End Region

        #Region "private methods"

        Private Sub SetDetailsGridProperties()
            DgvDetailsGrid.AutoGenerateColumns = False
            DgvDetailsGrid.AllowUserToResizeRows = False
            DgvDetailsGrid.ColumnCount = 10
            DgvDetailsGrid.ScrollBars = ScrollBars.None
            DgvDetailsGrid.AllowUserToOrderColumns = False
            DgvDetailsGrid.AllowUserToAddRows = False
            DgvDetailsGrid.AllowUserToDeleteRows = False
            DgvDetailsGrid.ReadOnly = True
        End Sub

        Private Sub SetDetailsGridColumnProperties()
            DgvDetailsGrid.Columns("ProductID").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("ProductName").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvDetailsGrid.Columns("SupplierID").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("CategoryID").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("QuantityPerUnit").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvDetailsGrid.Columns("UnitPrice").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("UnitPrice").DefaultCellStyle.Format = "0.00##"
            DgvDetailsGrid.Columns("UnitsInStock").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("UnitsOnOrder").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("ReorderLevel").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvDetailsGrid.Columns("Discontinued").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        End Sub

        Private Sub SetMasterGridProperties()
            DgvMasterGrid.AutoGenerateColumns = False
            DgvMasterGrid.AllowUserToResizeRows = False
            DgvMasterGrid.ColumnCount = 12
            DgvMasterGrid.ScrollBars = ScrollBars.None
            DgvMasterGrid.AllowUserToOrderColumns = False
            DgvMasterGrid.AllowUserToAddRows = False
            DgvMasterGrid.AllowUserToDeleteRows = False
            DgvMasterGrid.ReadOnly = True
        End Sub

        Private Sub SetMasterGridColumnProperties()
            DgvMasterGrid.Columns("SupplierIDMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DgvMasterGrid.Columns("CompanyNameMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("ContactNameMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("ContactTitleMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("AddressMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("CityMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("Region1Master").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("PostalCodeMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("CountryMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("PhoneMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("FaxMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            DgvMasterGrid.Columns("HomePageMaster").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
        End Sub

        Private Sub MoveDetailsToFirstPage()
            SetDetailsDataSource(False)
            ToolStripHelper.MoveToFirst(BnvDetailsNavMoveFirstItem, BnvDetailsNavMovePreviousItem, BnvDetailsNavMoveNextItem, BnvDetailsNavMoveLastItem)
        End Sub

        Private Sub MoveDetailsToPrevious()
            SetDetailsDataSource(False)
            ToolStripHelper.MoveToPrevious(BnvDetailsNavMoveFirstItem, BnvDetailsNavMovePreviousItem, BnvDetailsNavMoveNextItem, BnvDetailsNavMoveLastItem, _currentDetailsRecordNumber)
        End Sub

        Private Sub MoveDetailsToNext()
            SetDetailsDataSource(False)
            ToolStripHelper.MoveToNext(BnvDetailsNavMoveFirstItem, BnvDetailsNavMovePreviousItem, BnvDetailsNavMoveNextItem, BnvDetailsNavMoveLastItem, _currentDetailsPageNumber, _totalDetailsNumberOfPages)
        End Sub

        Private Sub MoveDetailsToLastPage()
            SetDetailsDataSource(False)
            ToolStripHelper.MoveToLast(BnvDetailsNavMoveFirstItem, BnvDetailsNavMovePreviousItem, BnvDetailsNavMoveNextItem, BnvDetailsNavMoveLastItem)
        End Sub

        Private Sub MoveMasterToFirstPage()
            SetMasterDataSource(False)
            ToolStripHelper.MoveToFirst(BnvMasterNavMoveFirstItem, BnvMasterNavMovePreviousItem, BnvMasterNavMoveNextItem, BnvMasterNavMoveLastItem)
            HightlightMasterRow(0)
        End Sub

        Private Sub MoveMasterToPrevious()
            SetMasterDataSource(False)
            ToolStripHelper.MoveToPrevious(BnvMasterNavMoveFirstItem, BnvMasterNavMovePreviousItem, BnvMasterNavMoveNextItem, BnvMasterNavMoveLastItem, _currentMasterRecordNumber)
            HightlightMasterRow(0)
        End Sub

        Private Sub MoveMasterToNext()
            SetMasterDataSource(False)
            ToolStripHelper.MoveToNext(BnvMasterNavMoveFirstItem, BnvMasterNavMovePreviousItem, BnvMasterNavMoveNextItem, BnvMasterNavMoveLastItem, _currentMasterPageNumber, _totalMasterNumberOfPages)
            HightlightMasterRow(0)
        End Sub

        Private Sub MoveMasterToLastPage()
            SetMasterDataSource(False)
            ToolStripHelper.MoveToLast(BnvMasterNavMoveFirstItem, BnvMasterNavMovePreviousItem, BnvMasterNavMoveNextItem, BnvMasterNavMoveLastItem)
            HightlightMasterRow(0)
        End Sub

        Private Sub SetDetailsDataSource(isSort As Boolean)
            If isSort Then
                _sortDetailsByExpression = GetDetailsSortByExpression()
            End If

            ' fill the datagridview
            DgvDetailsGrid.DataSource = Products.SelectSkipAndTakeBySupplierID(_gridDetailsNumberOfRows, _currentDetailsRecordNumber, _totalDetailsRecords, _sortDetailsByExpression, _supplierID1)
            DgvDetailsGrid.Columns(_sortDetailsColumnIndex).HeaderCell.SortGlyphDirection = _sortDetailsOrder

            If _totalDetailsRecords > 0 Then
                _totalDetailsNumberOfPages = CInt(Math.Ceiling(CSng(_totalDetailsRecords) / CSng(_gridDetailsNumberOfRows)))
                TscbDetailsPage.ComboBox.Items.Clear()

                ' fill page numbers in toolstripcombobox
                For page As Integer = 1 To _totalDetailsNumberOfPages
                    _isDetailsFireToolStripComboBoxSelectedIndexChanged = False
                    TscbDetailsPage.ComboBox.Items.Add(page)
                Next

                TscbDetailsPage.ComboBox.SelectedItem = _currentDetailsPageNumber
                _isDetailsFireToolStripComboBoxSelectedIndexChanged = True
            End If

            ResetDetailsNavButtonsToDefault()
        End Sub

        Private Sub SetMasterDataSource(isSort As Boolean)
            If isSort Then
                _sortMasterByExpression = GetMasterSortByExpression()
            End If

            ' fill the datagridview
            DgvMasterGrid.DataSource = Suppliers.SelectSkipAndTake(_gridMasterNumberOfRows, _currentMasterRecordNumber, _totalMasterRecords, _sortMasterByExpression)
            DgvMasterGrid.Columns(_sortMasterColumnIndex).HeaderCell.SortGlyphDirection = _sortMasterOrder

            If _totalMasterRecords > 0 Then
                _totalMasterNumberOfPages = CInt(Math.Ceiling(CSng(_totalMasterRecords) / CSng(_gridMasterNumberOfRows)))
                TscbMasterPage.ComboBox.Items.Clear()

                ' fill page numbers in toolstripcombobox
                For page As Integer = 1 To _totalMasterNumberOfPages
                    _isMasterFireToolStripComboBoxSelectedIndexChanged = False
                    TscbMasterPage.ComboBox.Items.Add(page)
                Next

                TscbMasterPage.ComboBox.SelectedItem = _currentMasterPageNumber
                _isMasterFireToolStripComboBoxSelectedIndexChanged = True
            End If

            ResetMasterNavButtonsToDefault()
        End Sub

        Private Function GetDetailsSortByExpression() As String
            _sortDetailsOrder = SortOrder.Descending

            Select Case _sortDetailsColumnIndex
                Case 0
                    If _sortDetailsByExpression = "ProductID" Then
                        Return "ProductID desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "ProductID"

                Case 1
                    If _sortDetailsByExpression = "ProductName" Then
                        Return "ProductName desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "ProductName"

                Case 2
                    If _sortDetailsByExpression = "SupplierID" Then
                        Return "SupplierID desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "SupplierID"

                Case 3
                    If _sortDetailsByExpression = "CategoryID" Then
                        Return "CategoryID desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "CategoryID"

                Case 4
                    If _sortDetailsByExpression = "QuantityPerUnit" Then
                        Return "QuantityPerUnit desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "QuantityPerUnit"

                Case 5
                    If _sortDetailsByExpression = "UnitPrice" Then
                        Return "UnitPrice desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "UnitPrice"

                Case 6
                    If _sortDetailsByExpression = "UnitsInStock" Then
                        Return "UnitsInStock desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "UnitsInStock"

                Case 7
                    If _sortDetailsByExpression = "UnitsOnOrder" Then
                        Return "UnitsOnOrder desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "UnitsOnOrder"

                Case 8
                    If _sortDetailsByExpression = "ReorderLevel" Then
                        Return "ReorderLevel desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "ReorderLevel"

                Case 9
                    If _sortDetailsByExpression = "Discontinued" Then
                        Return "Discontinued desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "Discontinued"

                Case Else
                    If _sortDetailsByExpression = "ProductID" Then
                        Return "ProductID desc"
                    End If

                    _sortDetailsOrder = SortOrder.Ascending
                    Return "ProductID"
            End Select
        End Function

        Private Function GetMasterSortByExpression() As String
            _sortMasterOrder = SortOrder.Descending

            Select Case _sortMasterColumnIndex
                Case 0
                    If _sortMasterByExpression = "SupplierID" Then
                        Return "SupplierID desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "SupplierID"

                Case 1
                    If _sortMasterByExpression = "CompanyName" Then
                        Return "CompanyName desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "CompanyName"

                Case 2
                    If _sortMasterByExpression = "ContactName" Then
                        Return "ContactName desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "ContactName"

                Case 3
                    If _sortMasterByExpression = "ContactTitle" Then
                        Return "ContactTitle desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "ContactTitle"

                Case 4
                    If _sortMasterByExpression = "Address" Then
                        Return "Address desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "Address"

                Case 5
                    If _sortMasterByExpression = "City" Then
                        Return "City desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "City"

                Case 6
                    If _sortMasterByExpression = "Region1" Then
                        Return "Region1 desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "Region1"

                Case 7
                    If _sortMasterByExpression = "PostalCode" Then
                        Return "PostalCode desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "PostalCode"

                Case 8
                    If _sortMasterByExpression = "Country" Then
                        Return "Country desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "Country"

                Case 9
                    If _sortMasterByExpression = "Phone" Then
                        Return "Phone desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "Phone"

                Case 10
                    If _sortMasterByExpression = "Fax" Then
                        Return "Fax desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "Fax"

                Case 11
                    If _sortMasterByExpression = "HomePage" Then
                        Return "HomePage desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "HomePage"

                Case Else
                    If _sortMasterByExpression = "SupplierID" Then
                        Return "SupplierID desc"
                    End If

                    _sortMasterOrder = SortOrder.Ascending
                    Return "SupplierID"
            End Select
        End Function

        Private Sub ResetDetailsNavButtonsToDefault()
            BnvDetailsNavCountItem.Text = "of " & _totalDetailsNumberOfPages & " pages"

            If _totalDetailsRecords <= _gridDetailsNumberOfRows Then
                BnvDetailsNavMoveNextItem.Enabled = False
                BnvDetailsNavMoveLastItem.Enabled = False
            Else
                BnvDetailsNavMoveNextItem.Enabled = True
                BnvDetailsNavMoveLastItem.Enabled = True
            End If
        End Sub

        Private Sub ResetMasterNavButtonsToDefault()
            BnvMasterNavCountItem.Text = "of " & _totalMasterNumberOfPages & " pages"

            If _totalMasterRecords <= _gridMasterNumberOfRows Then
                BnvMasterNavMoveNextItem.Enabled = False
                BnvMasterNavMoveLastItem.Enabled = False
            Else
                BnvMasterNavMoveNextItem.Enabled = True
                BnvMasterNavMoveLastItem.Enabled = True
            End If
        End Sub

        Private Sub HightlightDetailsRow(rowIndex As Integer)
            ' highlight row
            DgvDetailsGrid.ClearSelection()
            DgvDetailsGrid.Rows(rowIndex).Selected = True

            ' remember the current row clicked by the user
            _currentDetailsRowIndex = rowIndex
        End Sub

        Private Sub HightlightMasterRow(rowIndex As Integer)
            ' highlight row
            DgvMasterGrid.ClearSelection()
            DgvMasterGrid.Rows(rowIndex).Selected = True

            ' remember the current row clicked by the user
            _currentMasterRowIndex = rowIndex

            ' set details grid datasource based on selected item
            _supplierID1 = Convert.ToInt32(DgvMasterGrid.Rows(rowIndex).Cells("SupplierIDMaster").Value.ToString())

            SetDetailsDataSource(False)
        End Sub


        #End Region
    End Class
