Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditCategories

        Dim _isCategoryNameValid As Boolean
        Dim _categoryID As Integer
        Private _operation As CrudOperation

        Public Property CategoryID() As Integer
            Get
                Return _categoryID
            End Get
            Set(ByVal value As Integer)
                _categoryID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtCategoryName_TextChanged(sender As Object, e As EventArgs) Handles TxtCategoryName.TextChanged
            If Not String.IsNullOrEmpty(TxtCategoryName.Text) Then
                TxtCategoryName.BackColor = Color.White
                _isCategoryNameValid = True
            Else
                _isCategoryNameValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateCategories()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isCategoryNameValid Then
                errors += "Category Name is required!" & vbCrLf
                TxtCategoryName.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetCategoriesToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateCategories()
            ' place your code here
        End Sub
    End Class
