Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditCustomerDemographics

        Dim _isCustomerTypeIDValid As Boolean
        Dim _customerTypeID As String
        Private _operation As CrudOperation

        Public Property CustomerTypeID() As String
            Get
                Return _customerTypeID
            End Get
            Set(ByVal value As String)
                _customerTypeID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtCustomerTypeID_TextChanged(sender As Object, e As EventArgs) Handles TxtCustomerTypeID.TextChanged
            If Not String.IsNullOrEmpty(TxtCustomerTypeID.Text) Then
                TxtCustomerTypeID.BackColor = Color.White
                _isCustomerTypeIDValid = True
            Else
                _isCustomerTypeIDValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateCustomerDemographics()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isCustomerTypeIDValid Then
                errors += "Customer Type ID is required!" & vbCrLf
                TxtCustomerTypeID.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetCustomerDemographicsToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateCustomerDemographics()
            ' place your code here
        End Sub
    End Class
