Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditCustomers

        Dim _isCustomerIDValid As Boolean
        Dim _isCompanyNameValid As Boolean
        Dim _customerID As String
        Private _operation As CrudOperation

        Public Property CustomerID() As String
            Get
                Return _customerID
            End Get
            Set(ByVal value As String)
                _customerID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtCustomerID_TextChanged(sender As Object, e As EventArgs) Handles TxtCustomerID.TextChanged
            If Not String.IsNullOrEmpty(TxtCustomerID.Text) Then
                TxtCustomerID.BackColor = Color.White
                _isCustomerIDValid = True
            Else
                _isCustomerIDValid = False
            End If
        End Sub

        Private Sub TxtCompanyName_TextChanged(sender As Object, e As EventArgs) Handles TxtCompanyName.TextChanged
            If Not String.IsNullOrEmpty(TxtCompanyName.Text) Then
                TxtCompanyName.BackColor = Color.White
                _isCompanyNameValid = True
            Else
                _isCompanyNameValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateCustomers()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isCustomerIDValid Then
                errors += "Customer ID is required!" & vbCrLf
                TxtCustomerID.BackColor = Color.LightPink
            End If

            If Not _isCompanyNameValid Then
                errors += "Company Name is required!" & vbCrLf
                TxtCompanyName.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetCustomersToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateCustomers()
            ' place your code here
        End Sub
    End Class
