Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditEmployees

        Dim _isLastNameValid As Boolean
        Dim _isFirstNameValid As Boolean
        Dim _employeeID As Integer
        Private _operation As CrudOperation

        Public Property EmployeeID() As Integer
            Get
                Return _employeeID
            End Get
            Set(ByVal value As Integer)
                _employeeID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub UnboundAddEditEmployees_Load(sender As Object, e As EventArgs) Handles MyBase.Load
            SetDateFieldsToDefault()
        End Sub

        Private Sub TxtLastName_TextChanged(sender As Object, e As EventArgs) Handles TxtLastName.TextChanged
            If Not String.IsNullOrEmpty(TxtLastName.Text) Then
                TxtLastName.BackColor = Color.White
                _isLastNameValid = True
            Else
                _isLastNameValid = False
            End If
        End Sub

        Private Sub TxtFirstName_TextChanged(sender As Object, e As EventArgs) Handles TxtFirstName.TextChanged
            If Not String.IsNullOrEmpty(TxtFirstName.Text) Then
                TxtFirstName.BackColor = Color.White
                _isFirstNameValid = True
            Else
                _isFirstNameValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateEmployees()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Sub DtpBirthDate_ValueChanged(sender As Object, e As EventArgs) Handles DtpBirthDate.ValueChanged
            Me.DtpBirthDate.CustomFormat = "MM/dd/yyyy"
        End Sub

        Private Sub DtpHireDate_ValueChanged(sender As Object, e As EventArgs) Handles DtpHireDate.ValueChanged
            Me.DtpHireDate.CustomFormat = "MM/dd/yyyy"
        End Sub


        Private Sub SetDateFieldsToDefault()
            Me.DtpBirthDate.CustomFormat = " "
            Me.DtpBirthDate.Format = DateTimePickerFormat.Custom

            Me.DtpHireDate.CustomFormat = " "
            Me.DtpHireDate.Format = DateTimePickerFormat.Custom

        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isLastNameValid Then
                errors += "Last Name is required!" & vbCrLf
                TxtLastName.BackColor = Color.LightPink
            End If

            If Not _isFirstNameValid Then
                errors += "First Name is required!" & vbCrLf
                TxtFirstName.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetEmployeesToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateEmployees()
            ' place your code here
        End Sub
    End Class
