Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditOrderDetails

        Dim _isOrderIDValid As Boolean
        Dim _isProductIDValid As Boolean
        Dim _isUnitPriceValid As Boolean
        Dim _isQuantityValid As Boolean
        Dim _isDiscountValid As Boolean
        Dim _orderID As Integer
        Dim _productID As Integer
        Private _operation As CrudOperation

        Public Property OrderID() As Integer
            Get
                Return _orderID
            End Get
            Set(ByVal value As Integer)
                _orderID = value
            End Set
        End Property

        Public Property ProductID() As Integer
            Get
                Return _productID
            End Get
            Set(ByVal value As Integer)
                _productID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub CbxOrderID_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbxOrderID.SelectedIndexChanged
            If CbxOrderID.SelectedIndex <> 0 Then
                CbxOrderID.BackColor = Color.White
                _isOrderIDValid = True
            Else
                _isOrderIDValid = False
            End If
        End Sub

        Private Sub CbxProductID_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbxProductID.SelectedIndexChanged
            If CbxProductID.SelectedIndex <> 0 Then
                CbxProductID.BackColor = Color.White
                _isProductIDValid = True
            Else
                _isProductIDValid = False
            End If
        End Sub

        Private Sub MtbUnitPrice_TextChanged(sender As Object, e As EventArgs) Handles MtbUnitPrice.TextChanged
            If Not String.IsNullOrEmpty(MtbUnitPrice.Text) Then
                MtbUnitPrice.BackColor = Color.White
                _isUnitPriceValid = True
            Else
                _isUnitPriceValid = False
            End If
        End Sub

        Private Sub MtbQuantity_TextChanged(sender As Object, e As EventArgs) Handles MtbQuantity.TextChanged
            If Not String.IsNullOrEmpty(MtbQuantity.Text) Then
                MtbQuantity.BackColor = Color.White
                _isQuantityValid = True
            Else
                _isQuantityValid = False
            End If
        End Sub

        Private Sub MtbDiscount_TextChanged(sender As Object, e As EventArgs) Handles MtbDiscount.TextChanged
            If Not String.IsNullOrEmpty(MtbDiscount.Text) Then
                MtbDiscount.BackColor = Color.White
                _isDiscountValid = True
            Else
                _isDiscountValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateOrderDetails()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isOrderIDValid Then
                errors += "Order ID is required!" & vbCrLf
                CbxOrderID.BackColor = Color.LightPink
            End If

            If Not _isProductIDValid Then
                errors += "Product ID is required!" & vbCrLf
                CbxProductID.BackColor = Color.LightPink
            End If

            If Not _isUnitPriceValid Then
                errors += "Unit Price is required!" & vbCrLf
                MtbUnitPrice.BackColor = Color.LightPink
            End If

            If Not _isQuantityValid Then
                errors += "Quantity is required!" & vbCrLf
                MtbQuantity.BackColor = Color.LightPink
            End If

            If Not _isDiscountValid Then
                errors += "Discount is required!" & vbCrLf
                MtbDiscount.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetOrderDetailsToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateOrderDetails()
            ' place your code here
        End Sub
    End Class
