Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports NorthwindWinFormDynamic_VB.BusinessObject
Imports NorthwindWinFormDynamic_VB.Domain

    Public Class UnboundAddEditProducts

        Dim _isProductNameValid As Boolean
        Dim _productID As Integer
        Private _operation As CrudOperation

        Public Property ProductID() As Integer
            Get
                Return _productID
            End Get
            Set(ByVal value As Integer)
                _productID = value
            End Set
        End Property


        Public Property Operation() As String
            Get
                Return _operation
            End Get
            Set(ByVal value As String)
                _operation = value
            End Set
        End Property

        Private Sub TxtProductName_TextChanged(sender As Object, e As EventArgs) Handles TxtProductName.TextChanged
            If Not String.IsNullOrEmpty(TxtProductName.Text) Then
                TxtProductName.BackColor = Color.White
                _isProductNameValid = True
            Else
                _isProductNameValid = False
            End If
        End Sub

        Private Sub BtnSave_Click(sender As Object, e As EventArgs) Handles BtnSave.Click
            Dim errors As String = ValidateEntries()

            If String.IsNullOrEmpty(errors) Then
                AddOrUpdateProducts()
                WindowHelper.CloseParent(Me)
            Else
                MessageBox.Show(errors, "Validation errors")
            End If
        End Sub

        Private Sub BtnCancel_Click(sender As Object, e As EventArgs) Handles BtnCancel.Click
            WindowHelper.CloseParent(Me)
        End Sub

        Private Function ValidateEntries() As String
            Dim errors As String = String.Empty

            ' validate
            If Not _isProductNameValid Then
                errors += "Product Name is required!" & vbCrLf
                TxtProductName.BackColor = Color.LightPink
            End If

            Return errors
        End Function

        Friend Sub GetProductsToEdit()
            ' place your code here
        End Sub

        Private Sub AddOrUpdateProducts()
            ' place your code here
        End Sub
    End Class
